package de.hft.stuttgart.citydoctor2.ziploader;

import de.hft.stuttgart.citydoctor2.parser.ParserConfiguration;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;


import java.io.IOException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;

public class ZipParser {

    private static final Logger logger = LogManager.getLogger(ZipParser.class);

    public static List<CityGmlZipEntry> parseZipFile(String zipFile, ParserConfiguration config) {
        ArrayList<CityGmlZipEntry> archiveEntries = new ArrayList<>();
        try (ZipFile zipFileObj = new ZipFile(zipFile)) {
            for (Enumeration<? extends ZipEntry> entries = zipFileObj.entries(); entries.hasMoreElements();) {
                ZipEntry entry = entries.nextElement();
                if (entry.isDirectory()) {
                    continue;
                }
                if (entry.getName().endsWith(".gml")) {
                    archiveEntries.add(CityGmlZipEntry.of(entry, config, zipFile));
                }
            }
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        return archiveEntries;
    }

}
